#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "Viewer.h"

class QMenu;
class QToolBar;
class QAction;
class QLabel;
class QSlider;
class QToolButton;
class Grid;
class QString;


class MainWindow : public QMainWindow
{
	Q_OBJECT


	Viewer *viewer;
	Grid   *grid;
	QString name;

  public:
	MainWindow();
	~MainWindow();


  protected:
	void init();
	void buildInterface();
	void createMenus();
	void createActions();
	void createToolbars();

	void loadXML(const QString& nameXML);

	void readSettings();
	void writeSettings();

  public slots:
	void info();
	void about();
	void openDir();

  protected:
    QMenu *fileMenu;
    QMenu *helpMenu;

	// Toolbars
    QToolBar *toolBar;

	// All actions
    QAction *openAct;      //!< Open file action...
    QAction *quitAct;      //!< Close !
    QAction *aboutAct;     //!< Action for show About dialog box
    QAction *infoAct;      //!< Technical informations
};


#endif

