#ifndef VIEWER_H
#define VIEWER_H

#include <QtCore>
#include <QWidget>


class Grid;
class QPainter;
class QPixmap;
class QPoint;

class Viewer : public QWidget
{
	Q_OBJECT

	Grid *grid;

  public:
	Viewer(Grid *_grid = 0, int w=360, int h=480, QWidget *parent = 0);

  public slots:
	void paintEvent(QPaintEvent *);
	void repaint();
	void actualize(Grid *ptr);
	void select(int x, int y);

	void mousePressEvent  (QMouseEvent *event);
	void resizeEvent(QResizeEvent *event);

  protected:
	void unproject(const QPoint& p, int& i, int& j);


  protected:
	int sI,sJ;
	int dim, inc, startX, startY;
	QPixmap  *pixmap[10];
};

#endif
